from typing import List

from classiq.interface.combinatorial_optimization.examples.ascending_sequence import (
    ascending_sequence,
)
from classiq.interface.combinatorial_optimization.examples.ilp import ilp
from classiq.interface.combinatorial_optimization.examples.integer_portfolio_optimization import (
    integer_portfolio_optimization,
)
from classiq.interface.combinatorial_optimization.examples.knapsack import knapsack
from classiq.interface.combinatorial_optimization.examples.maxcut import maxcut
from classiq.interface.combinatorial_optimization.examples.mds import mds
from classiq.interface.combinatorial_optimization.examples.mht import (
    build_mht_pyomo_model as mht,
)
from classiq.interface.combinatorial_optimization.examples.mis import mis
from classiq.interface.combinatorial_optimization.examples.mvc import mvc
from classiq.interface.combinatorial_optimization.examples.portfolio_optimization import (
    portfolio_optimization,
)
from classiq.interface.combinatorial_optimization.examples.portfolio_variations import (
    portfolio_optimization_binary,
    portfolio_optimization_integer,
)
from classiq.interface.combinatorial_optimization.examples.set_cover import set_cover
from classiq.interface.combinatorial_optimization.examples.tsp import tsp
from classiq.interface.combinatorial_optimization.examples.tsp_digraph import (
    tsp_digraph,
)

__all__ = [
    "ascending_sequence",
    "ilp",
    "integer_portfolio_optimization",
    "knapsack",
    "maxcut",
    "mds",
    "mht",
    "mis",
    "mvc",
    "portfolio_optimization",
    "portfolio_optimization_binary",
    "portfolio_optimization_integer",
    "set_cover",
    "tsp",
    "tsp_digraph",
]


def __dir__() -> List[str]:
    return __all__
