from typing import List

from ..datasets import builtin_datasets
from ..datasets.builtin_datasets import (
    DATALOADER_NOT,
    DATALOADER_SUBSET_PARITY,
    DATALOADER_XOR,
    DATASET_NOT,
    DATASET_SUBSET_PARITY,
    DATASET_XOR,
)
from ..datasets.dataset_not import DatasetNot
from ..datasets.dataset_parity import DatasetParity, DatasetSubsetParity
from ..datasets.dataset_xor import DatasetXor
from ..datasets.datasets_utils import state_to_label, state_to_weights

__all__ = [
    "builtin_datasets",
    "DatasetNot",
    "DATASET_NOT",
    "DATALOADER_NOT",
    "DatasetXor",
    "DATASET_XOR",
    "DATALOADER_XOR",
    "DatasetSubsetParity",
    "DATASET_SUBSET_PARITY",
    "DATALOADER_SUBSET_PARITY",
    "DatasetParity",
    "state_to_weights",
    "state_to_label",
]


def __dir__() -> List[str]:
    return __all__
