ANALYZER_PREFIX = "/analyzer"
CHEMISTRY_PREFIX = "/chemistry"
EXECUTION_PREFIX = "/execution"
CONVERSION_PREFIX = "/conversion"

EXECUTION_NON_VERSIONED_PREFIX = "/execution/v1"
SYNTHESIS_NON_VERSIONED_PREFIX = "/synthesis/v1"

ANALYZER_CIRCUIT_PAGE = "circuit"
DEFAULT_IDE_FE_APP = "https://platform.classiq.io/"

ANALYZER_HC_GRAPH = "/graphs/hardware_connectivity"
ANALYZER_HC_GRAPH_FULL_PATH = ANALYZER_PREFIX + ANALYZER_HC_GRAPH

ANALYZER_HC_TABLE_GRAPH = "/graphs/hardware_comparison_table"
ANALYZER_HC_TABLE_GRAPH_FULL_PATH = ANALYZER_PREFIX + ANALYZER_HC_TABLE_GRAPH

ANALYZER_HC_GRAPH_NEW = "/graphs/hardware_connectivity/new"

ANALYZER_OPTIONAL_DEVICES = "/graphs/available_devices"
ANALYZER_OPTIONAL_DEVICES_FULL_PATH = ANALYZER_PREFIX + ANALYZER_OPTIONAL_DEVICES

TASKS_SUFFIX = "/tasks"
RB = "/rb"
ANALYZER_DATA_TASK = f"{TASKS_SUFFIX}/data"
ANALYZER_QASM_TASK = f"{TASKS_SUFFIX}/qasm"
IDE_EVENT_TASK = f"{TASKS_SUFFIX}/event"
DATA_DOG_EVENT_TASK = f"{TASKS_SUFFIX}/data_dog_event"

ANALYZER_DATA_TASK_UPLOAD_FILE = f"{TASKS_SUFFIX}/data/file_upload"
ANALYZER_DATA_FULL_PATH = f"{ANALYZER_PREFIX}{ANALYZER_DATA_TASK}"
ANALYZER_QASM_FULL_PATH = f"{ANALYZER_PREFIX}{ANALYZER_QASM_TASK}"
IDE_EVENT_TASK_FULL_PATH = f"{ANALYZER_PREFIX}{IDE_EVENT_TASK}"
DATA_DOG_EVENT_TASK_FULL_PATH = f"{ANALYZER_PREFIX}{DATA_DOG_EVENT_TASK}"

IDE_QASM_TASK = f"{TASKS_SUFFIX}/generated_circuit_from_qasm"
IDE_QASM_FULL_PATH = f"{ANALYZER_PREFIX}{IDE_QASM_TASK}"
TASKS_GENERATE_SUFFIX = TASKS_SUFFIX + "/generate"
TASKS_VISUALIZE_SUFFIX = TASKS_SUFFIX + "/visualize"
TASKS_VISUAL_MODEL_SUFFIX = TASKS_SUFFIX + "/visual_model"
TASKS_SOLVE_SUFFIX = "/tasks/solve"

CHEMISTRY_QMOD_PATH = "/generate_model/chemistry/qmod"
GROVER_QMOD_PATH = "/generate_model/grover/qmod"
FINANCE_QMOD_PATH = "/generate_model/finance/qmod"


TASK_TRAIN_SUFFIX = TASKS_SUFFIX + "/train"
TASK_TEST_SUFFIX = TASKS_SUFFIX + "/test"
TASK_PREDICT_SUFFIX = TASKS_SUFFIX + "/predict"
TASK_RB_SUFFIX = TASKS_SUFFIX + RB
TASKS_GENERATE_FULL_PATH = TASKS_GENERATE_SUFFIX

EXECUTION_JOBS_SUFFIX = "/jobs"
EXECUTION_JOBS_FULL_PATH = EXECUTION_PREFIX + EXECUTION_JOBS_SUFFIX
EXECUTION_JOBS_NON_VERSIONED_FULL_PATH = (
    EXECUTION_NON_VERSIONED_PREFIX + EXECUTION_JOBS_SUFFIX
)

ANALYZER_FULL_PATH = ANALYZER_PREFIX + TASKS_SUFFIX
ANALYZER_RB_FULL_PATH = ANALYZER_PREFIX + TASK_RB_SUFFIX
GENERATE_RESOURCE_ESTIMATOR_REPORT = "/resource_estimator_report"

TASKS_SOLVE_EXACT_SUFFIX = "/tasks/solve_exact"

GENERATE_HAMILTONIAN_SUFFIX = "/generate_hamiltonian"
GENERATE_HAMILTONIAN_FULL_PATH = (
    SYNTHESIS_NON_VERSIONED_PREFIX + GENERATE_HAMILTONIAN_SUFFIX
)

CONVERSION_GENERATED_CIRCUIT_TO_EXECUTION_INPUT_SUFFIX = "/execution_input"
CONVERSION_GENERATED_CIRCUIT_TO_EXECUTION_INPUT_FULL = (
    CONVERSION_PREFIX + CONVERSION_GENERATED_CIRCUIT_TO_EXECUTION_INPUT_SUFFIX
)

STATIC_SEMANTICS_VALIDATION_PATH = "/validate_static_semantics"
